/******************************************************************************
* OpenMP Example - Hello World - C/C++ Version
* FILE: omp_hello.c
* DESCRIPTION:
*   In this simple example, the master thread forks a parallel region.
*   All threads in the team obtain their unique thread number and print it.
*   The master thread only prints the total number of threads.  Two OpenMP
*   library routines are used to obtain the number of threads and each
*   thread's number.
* SOURCE: Blaise Barney  5/99
* LAST REVISED: 
******************************************************************************/

/* Borrowed for CS 338 Example, Jim Teresco, Williams College
   Source: 
   http://www.llnl.gov/computing/tutorials/workshops/workshop/openMP/samples/C/omp_hello.c

   $Id$
*/

#include <omp.h>
#include <stdio.h>

main ()  {

  int nthreads, tid;
 
/* Fork a team of threads giving them their own copies of variables */
#pragma omp parallel private(nthreads, tid)
  {

  /* Obtain thread number */
  tid = omp_get_thread_num();
  printf("Hello World from thread = %d\n", tid);

  /* Only master thread does this */
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("Number of threads = %d\n", nthreads);
    }

  }  /* All threads join master thread and disband */

}
